+++
title = "Link for 2020-04-22"
date = 2020-04-22

[taxonomies]
tags = ["links", "principles", "manifesto", "google", "privacy", "ai",
"terms and conditions", "pandoc", "vim", "yaml", "oath", "amazon",
"dependency injection", "rust"]
+++

Valuable Dev Principles, Terms and Conditions for Stealing Ideas, Google
"Privacy", Google Biased AI, Pandoc for Books, YAML, Oaths, Amazon, DI in
Rust.

<!-- more -->

# [The Valuable Dev Principles](https://thevaluable.dev/page/principles/)

I know we are all tired of those manifestos and such, to the point that we are
signing those without even reading the whole thing. But this isn't this kind
of article: It discusses a lot of what the "value" we, developers, produce.

(Ok, it is _not_ a manifesto, but you have to agree that the title sound like
one.)

# [Hundreds of companies assert usage rights over all ideas sent through their services](https://mailchi.mp/8b0a4a81ae08/new-blog-post-why-economists-need-bureaucracy-9265154?e=4dca83bc3b)

I mentioned the perils of picking a license a few days ago, and today we have
an article about the perils of... licenses to use. 

Basically, one very prominent app have a clause that says they can use
everything that goes into their services, including "any ideas, inventions,
concepts, techniques or know-how disclosed wherein". Sounds awesome, doesn't
it? You're there, discussing some wild ideas with your friend, you guys come
with the next big app idea and suddenly... this company releases it before you
two. You think "I'll sue them", and they will just point to the terms and
services and show that you _allowed_ them to do this.

Ok, hyperboles, I know. But the fact that terms and conditions are so large
and so hard to read shows that we have a problem[^1].

# [Google can still use Bluetooth to track your Android phone when Bluetooth is turned off](https://qz.com/1169760/phone-data/)

While Apple abuses its walled garden to get some things outside some
ecosystem, Google does what Google does: Capture your data even when you say
you don't want data to be captured.

This should come with no surprise to anyone watching Google in the last years.

# [Google Cloud's AI recog code 'biased' against black people – and more from ML land](https://www.theregister.co.uk/2020/04/13/ai_roundup/)

There are a bunch of topics there, but the one that caught my eye was exactly
the "Google AI biased against black people". It's not the first time I read
something like that: When Google Photos got auto-labeling, it tagged black
people as "gorillas".

It seems Google still doesn't understand how those things work: If you hire a
bunch of white people -- and only white people -- what do you think will
happen with your learning profiles?

Also, remember these two stories next time Google do a promotion for MLK day.

# [Writing a Book with Pandoc, Make, and Vim](https://keleshev.com/my-book-writing-setup/)

One thing I took from this: Pandoc can convert Markdown files directly into
PDF.

# [YAML: probably not so great after all](https://www.arp242.net/yaml-config.html)

I mentioned this before: Sometimes, the problem with the configuration format
is not the format itself, but the way the configuration _options_ were
created.

And I know that, when talking about configuration files, YAML is the favourite
format to get some bashing.

But you can agree that some options here make sense, but aren't being
processed in the right way.

... although I have to wonder if some issues would be solved by processing the
YAML in a language that has strong types, so the incoming "013" would be
processed as a string instead of an octal. Maybe we need a YAML-schema format
to feed into the YAML processing libraries so they know the type? And if
that's the case, can't we come up with a format that already has a type
definition in it?

# [Types Over Strings: Extensible Architectures in Rust](http://willcrichton.net/notes/types-over-strings/)

How to do a proper dependency injection in Rust.

# [Collections: Oaths! How do they Work?](https://acoup.blog/2019/06/28/collections-oaths-how-do-they-work/)

Completely unrelated to technology -- which is what I usually post -- but this
article about the meaning and workings of an oath and a vow is really
interesting.

# [Amazon fires three critics of warehouse conditions in pandemic](https://www.reuters.com/article/us-health-coronavirus-amazon-com-warehou/amazon-fires-two-employees-critical-of-warehouse-working-conditions-idUSKCN21W0UI)

You know, there is something _really stupid_ when someone is criticizing their
own company and that company fires that person. What would you expect? People
claiming "Yeah, you can't bad mouth your company!"?

---

[^1]: This is kinda getting the catchphrase for these posts, isn't it?

---

This list of links was build with the help of:

* [Adrian Cochrane](https://floss.social/@alcinnz)
* [HN Tooter](https://mastodon.social/@hntooter)
* [IT News](https://schleuss.online/@itnewsbot)
* [Lili Saintcrow ](https://raggedfeathers.com/@lilithsaintcrow)
* [newsbot](https://mastodon.social/@newsbot)
